Index: palm/trunk/SOURCE/pmc_client.f90
===================================================================
--- palm/trunk/SOURCE/pmc_client.f90	(revision 1763)
+++ palm/trunk/SOURCE/pmc_client.f90	(revision 1764)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! cpp-statement added (nesting can only be used in parallel mode),
+! all kinds given in PALM style
 !
 ! Former revisions:
@@ -35,9 +36,14 @@
 !------------------------------------------------------------------------------!
 
+#if defined( __parallel )
 
     use, intrinsic :: iso_c_binding
 
-    USE  mpi
-    USE  kinds,         ONLY: wp, iwp
+#if defined( __lc )
+    USE MPI
+#else
+    INCLUDE "mpif.h"
+#endif
+    USE  kinds
     USE  PMC_general,   ONLY: ClientDef, DA_NameDef, DA_Namelen, PMC_STATUS_OK, PMC_DA_NAME_ERR, PeDef, ArrayDef, &
                                          DA_Desclen, DA_Namelen, PMC_G_SetName, PMC_G_GetName
@@ -51,5 +57,7 @@
 !   data local to this MODULE
     Type(ClientDef)                       :: me
-    INTEGER, PARAMETER                    :: dp = wp
+!-- TO_DO: what is the meaning of this? Could variables declared in this module
+!--        also have single precision?
+!    INTEGER, PARAMETER                    :: dp = wp
 
     INTEGER, save                         :: myIndex = 0                !Counter and unique number for Data Arrays
@@ -310,4 +318,5 @@
     SUBROUTINE PMC_C_Set_DataArray_2d (array)
        IMPLICIT none
+!--    TO_DO: is double precision absolutely required here?
        REAL(kind=dp),INTENT(IN),DIMENSION(:,:)    :: array
        !-- local variables
@@ -344,4 +353,5 @@
     SUBROUTINE PMC_C_Set_DataArray_3d (array)
        IMPLICIT none
+!--    TO_DO: is double precision absolutely required here?
        REAL(kind=dp),INTENT(IN),DIMENSION(:,:,:)  :: array
        !-- local variables
@@ -377,9 +387,10 @@
 
    SUBROUTINE PMC_C_setInd_and_AllocMem
+
       IMPLICIT none
 
       INTEGER                                 :: i, ierr
       INTEGER                                 :: arlen, myIndex, tag
-      INTEGER(kind=8)                         :: bufsize                   ! Size of MPI data Window
+      INTEGER(idp)                            :: bufsize                   ! Size of MPI data Window
       TYPE(PeDef),POINTER                     :: aPE
       TYPE(ArrayDef),POINTER                  :: ar
@@ -574,6 +585,4 @@
     END SUBROUTINE PMC_C_PutBuffer
 
-
-! Private SUBROUTINEs
-
+#endif
 END MODULE pmc_client
Index: palm/trunk/SOURCE/pmc_general.f90
===================================================================
--- palm/trunk/SOURCE/pmc_general.f90	(revision 1763)
+++ palm/trunk/SOURCE/pmc_general.f90	(revision 1764)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! cpp-statement added (nesting can only be used in parallel mode),
+! all kinds given in PALM style
 !
 ! Former revisions:
@@ -35,7 +36,14 @@
 !------------------------------------------------------------------------------!
 
-
+#if defined( __parallel )
    use, intrinsic :: iso_c_binding
-   USE            :: MPI
+
+   USE kinds
+
+#if defined( __lc )
+    USE MPI
+#else
+    INCLUDE "mpif.h"
+#endif
 
    IMPLICIT none
@@ -65,5 +73,5 @@
       INTEGER                       :: dim_order                   ! Order of Dimensions: 2 = 2D array, 33 = 3D array
       TYPE (c_ptr)                  :: data                        ! Pointer of data in server space
-      INTEGER(kind=8)               :: BufIndex                    ! index in Send Buffer
+      INTEGER(idp)                  :: BufIndex                    ! index in Send Buffer
       INTEGER                       :: BufSize                     ! size in Send Buffer
       TYPE (c_ptr)                  :: SendBuf                     ! Pointer of Data in Send buffer
@@ -76,5 +84,5 @@
 
    TYPE, PUBLIC :: PeDef
-      INTEGER(KIND=8)                     :: NrEle                 ! Number of Elemets
+      INTEGER(idp)                        :: NrEle                 ! Number of Elemets
       TYPE (xy_ind), POINTER,DIMENSION(:) :: locInd                ! xy index local array for remote PE
       TYPE( ArrayDef), POINTER            :: Arrays                ! Pointer to Data Array List (Type ArrayDef)
@@ -83,5 +91,5 @@
 
    TYPE, PUBLIC :: ClientDef
-      INTEGER(KIND=8)               :: TotalBufferSize
+      INTEGER(idp)                  :: TotalBufferSize
       INTEGER                       :: model_comm                  ! Communicator of this model
       INTEGER                       :: inter_comm                  ! Inter communicator model and client
@@ -258,3 +266,4 @@
     END FUNCTION DA_List_next
 
+#endif
 end MODULE pmc_general
Index: palm/trunk/SOURCE/pmc_handle_communicator.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1763)
+++ palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1764)
@@ -1,4 +1,3 @@
-MODULE PMC_handle_communicator
-
+ MODULE PMC_handle_communicator
 
 !--------------------------------------------------------------------------------!
@@ -21,5 +20,10 @@
 ! Current revisions:
 ! ------------------
-!
+! pmc_layout type: comm_cpl and comm_parent removed, character "name" moved at
+! the beginning of the variable list,
+! domain layout is read with new NAMELIST nestpar from standard file PARIN,
+! MPI-datatype REAL8 replaced by REAL, kind=8 replaced by wp,
+! variable domain_layouts instead of m_couplers introduced for this NAMELIST,
+! general format changed to PALM style
 !
 ! Former revisions:
@@ -30,40 +34,42 @@
 ! Initial revision by K. Ketelsen
 !
-! Intoduction of the pure FORTRAN Palm Model Coupler     (PMC)  12.11.2015  K. Ketelsen
-!
 ! Description:
 ! ------------
-!
-! Handle MPI Communicator in Palm Model Coupler
+! Handle MPI communicator in PALM model coupler
 !------------------------------------------------------------------------------!
 
-   USE      mpi
-   USE      pmc_general,                        &
-      ONLY: PMC_STATUS_OK, PMC_STATUS_ERROR, PMC_MAX_MODELL
-
-   IMPLICIT none
-
-   ! Define Types
-
-   type PMC_layout
-      INTEGER                         :: comm_parent
-      INTEGER                         :: comm_cpl
-      INTEGER                         :: Id
-      INTEGER                         :: Parent_id
-
-      INTEGER                         :: npe_x
-      INTEGER                         :: npe_y
-
-      REAL(kind=8)                    :: lower_left_x
-      REAL(kind=8)                    :: lower_left_y
-
-      CHARACTER(len=32)               :: name
-   END type PMC_layout
-
-   ! return status
-   PUBLIC                               PMC_STATUS_OK, PMC_STATUS_ERROR
-   INTEGER,parameter,PUBLIC          :: PMC_ERROR_NPES = 1                       ! illegal Number of PEs
-   INTEGER,parameter,PUBLIC          :: PMC_ERROR_MPI  = 2                       ! MPI Error
-   INTEGER,parameter,PUBLIC          :: PMC_ERRO_NOF   = 3                       ! No couple layout file found
+#if defined( __parallel )
+    USE kinds
+
+#if defined( __lc )
+    USE MPI
+#else
+    INCLUDE "mpif.h"
+#endif
+
+   USE pmc_general,                                                            &
+       ONLY: pmc_status_ok, pmc_status_error, pmc_max_modell
+
+   IMPLICIT NONE
+
+   TYPE pmc_layout
+
+      CHARACTER(len=32) ::  name
+
+      INTEGER  ::  id
+      INTEGER  ::  parent_id
+      INTEGER  ::  npe_x
+      INTEGER  ::  npe_y
+
+      REAL(wp) ::  lower_left_x
+      REAL(wp) ::  lower_left_y
+
+   END TYPE pmc_layout
+
+   PUBLIC  pmc_status_ok, pmc_status_error
+
+   INTEGER, PARAMETER, PUBLIC ::  pmc_error_npes          = 1  ! illegal number of PEs
+   INTEGER, PARAMETER, PUBLIC ::  pmc_namelist_error      = 2  ! error(s) in nestpar namelist
+   INTEGER, PARAMETER, PUBLIC ::  pmc_no_namelist_found   = 3  ! No couple layout file found
 
    ! Coupler Setup
@@ -72,5 +78,5 @@
    INTEGER                                    :: m_Parent_id  !Coupler id of parent of this model
    INTEGER                                    :: m_NrOfCpl    !Number of Coupler in layout file
-   type(PMC_layout),DIMENSION(PMC_MAX_MODELL) :: m_couplers   !Information of all coupler
+   TYPE(PMC_layout),DIMENSION(PMC_MAX_MODELL) :: m_couplers   !Information of all coupler
 
    ! MPI settings
@@ -91,9 +97,7 @@
    INTEGER,DIMENSION(:),POINTER,PUBLIC :: PMC_Server_for_Client
 
-   !INTERFACE Section
-
-   INTERFACE PMC_is_RootModel
-      MODULE PROCEDURE PMC_is_RootModel
-   END INTERFACE PMC_is_RootModel
+   INTERFACE pmc_is_rootmodel
+      MODULE PROCEDURE pmc_is_rootmodel
+   END INTERFACE pmc_is_rootmodel
 
    INTERFACE PMC_get_local_model_info
@@ -101,221 +105,351 @@
    END INTERFACE PMC_get_local_model_info
 
-   PUBLIC PMC_init_model,PMC_get_local_model_info, PMC_is_RootModel
-CONTAINS
-
-   SUBROUTINE PMC_init_model (comm, PMC_status)
-      IMPLICIT     none
-      INTEGER,INTENT(OUT)                 :: comm
-      INTEGER,INTENT(OUT)                 :: PMC_status
-
-      !-- local declarations
-      INTEGER                             :: i,istat, ierr
-      INTEGER,DIMENSION(PMC_MAX_MODELL+1) :: start_PE
-      INTEGER                             :: m_my_CPL_rank
-      INTEGER                             :: tag, ClientCount
-      INTEGER,DIMENSION(PMC_MAX_MODELL)   :: activeServer        !I am active server for this client ID
-
-      PMC_status   = PMC_STATUS_OK
+   PUBLIC pmc_get_local_model_info, pmc_init_model, pmc_is_rootmodel
+
+ CONTAINS
+
+   SUBROUTINE pmc_init_model( comm, nesting_mode, pmc_status )
+
+      USE control_parameters,                                                  &
+          ONLY:  message_string
+
+      USE pegrid,                                                              &
+          ONLY:  myid
+
+      IMPLICIT NONE
+
+      CHARACTER(LEN=7), INTENT(OUT) ::  nesting_mode
+
+      INTEGER, INTENT(OUT)                ::  comm
+      INTEGER, INTENT(OUT)                ::  pmc_status
+
+      INTEGER                             ::  i, ierr, istat
+      INTEGER,DIMENSION(pmc_max_modell+1) ::  start_pe
+      INTEGER                             ::  m_my_cpl_rank
+      INTEGER                             ::  tag, clientcount
+      INTEGER,DIMENSION(pmc_max_modell)   ::  activeserver  ! I am active server for this client ID
+
+      pmc_status   = pmc_status_ok
       comm         = -1
-      m_my_CPL_id  = -1
-      ClientCount  = 0
-      activeServer = -1
-      start_PE(:)  = 0
-
-      CALL  MPI_Comm_rank (MPI_COMM_WORLD, m_world_rank, istat)
-      CALL  MPI_Comm_size (MPI_COMM_WORLD, m_world_npes, istat)
-
-      if(m_world_rank == 0) then ! only PE 0 of root model reads
-
-         CALL read_coupling_layout (PMC_status)
-
-         IF (PMC_status /= PMC_ERRO_NOF  ) THEN
-            ! Compute Start PE of every model
-            start_PE(1) = 0
-            do i=2,m_NrOfCpl+1
-               start_pe(i) = start_PE(i-1) + m_couplers(i-1)%npe_x*m_couplers(i-1)%npe_y
-            END do
-            if(start_pe(m_NrOfCpl+1) /= m_world_npes)   then
-               if(m_world_rank == 0) then
-                  write(0,*) 'PMC ERROR: Coupler Setup Not equal Nr. MPI procs ',start_pe(m_NrOfCpl+1),m_world_npes
-               END if
-               CALL MPI_Abort (MPI_COMM_WORLD, ierr, istat)
-            END if
-         END IF
-      END if
-
-      CALL MPI_Bcast (PMC_status, 1,          MPI_INTEGER, 0, MPI_COMM_WORLD, istat)
-      IF (PMC_status == PMC_ERRO_NOF  ) THEN
-         if(m_world_rank == 0)  write(0,*) 'PMC ERROR: file PMC_couple_layout not found'
-         CALL MPI_Abort (MPI_COMM_WORLD, ierr, istat)
-      END IF
-
-      CALL MPI_Bcast (m_NrOfCpl, 1,          MPI_INTEGER, 0, MPI_COMM_WORLD, istat)
-      CALL MPI_Bcast (start_PE, m_NrOfCpl+1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat)
-
-      !   Broadcast coupling layout
-
-      do i=1,m_NrOfCpl
-         CALL MPI_Bcast (m_couplers(i)%name, len(m_couplers(i)%name ), MPI_CHARACTER, 0, MPI_COMM_WORLD, istat)
-         CALL MPI_Bcast (m_couplers(i)%id,           1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat)
-         CALL MPI_Bcast (m_couplers(i)%Parent_id,    1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat)
-         CALL MPI_Bcast (m_couplers(i)%npe_x,        1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat)
-         CALL MPI_Bcast (m_couplers(i)%npe_y,        1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat)
-         CALL MPI_Bcast (m_couplers(i)%lower_left_x, 1, MPI_REAL8,   0, MPI_COMM_WORLD, istat)
-         CALL MPI_Bcast (m_couplers(i)%lower_left_y, 1, MPI_REAL8,   0, MPI_COMM_WORLD, istat)
-      END do
-
-      ! Assign global MPI processes to individual models by setting the couple id
-
-      do i=1,m_NrOfCpl
-         if(m_world_rank >= start_PE(i) .and. m_world_rank < start_PE(i+1) ) then
-            m_my_CPL_id = i
+      m_my_cpl_id  = -1
+      clientcount  =  0
+      activeserver = -1
+      start_pe(:)  =  0
+
+      CALL  MPI_COMM_RANK( MPI_COMM_WORLD, m_world_rank, istat )
+      CALL  MPI_COMM_SIZE( MPI_COMM_WORLD, m_world_npes, istat )
+!
+!--   Only PE 0 of root model reads
+      IF ( m_world_rank == 0 )  THEN
+
+         CALL read_coupling_layout( nesting_mode, pmc_status )
+
+         IF ( pmc_status /= pmc_no_namelist_found  .AND.                       &
+              pmc_status /= pmc_namelist_error )                               &
+         THEN
+!
+!--         Calculate start PE of every model
+            start_pe(1) = 0
+            DO  i = 2, m_nrofcpl+1
+               start_pe(i) = start_pe(i-1) +                                   &
+                             m_couplers(i-1)%npe_x * m_couplers(i-1)%npe_y
+            ENDDO
+
+!
+!--         The number of cores provided with the run must be the same as the
+!--         total sum of cores required by all nest domains
+!--         TO_DO: can we use > instead of /= ?
+            IF ( start_pe(m_nrofcpl+1) /= m_world_npes )  THEN
+!--            TO_DO: this IF statement is redundant
+               IF ( m_world_rank == 0 )  THEN
+                  WRITE ( message_string, '(A,I6,A,I6,A)' )                    &
+                                  'nesting-setup requires more MPI procs (',   &
+                                  start_pe(m_nrofcpl+1), ') than provided (',  &
+                                  m_world_npes,')'
+                  CALL message( 'pmc_init_model', 'PA0229', 3, 2, 0, 6, 0 )
+               ENDIF
+            ENDIF
+
+         ENDIF
+
+      ENDIF
+!
+!--   Broadcast the read status. This synchronises all other PEs with PE 0 of
+!--   the root model. Without synchronisation, they would not behave in the
+!--   correct way (e.g. they would not return in case of a missing NAMELIST)
+      CALL MPI_BCAST( pmc_status, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
+
+      IF ( pmc_status == pmc_no_namelist_found )  THEN
+!
+!--      Not a nested run; return the MPI_WORLD communicator
+         comm = MPI_COMM_WORLD
+         RETURN
+
+      ELSEIF ( pmc_status == pmc_namelist_error )  THEN
+!
+!--      Only the root model gives the error message. Others are aborted by the
+!--      message-routine with MPI_ABORT. Must be done this way since myid and
+!--      comm2d have not yet been assigned at this point.
+         IF ( m_world_rank == 0 )  THEN
+            message_string = 'errors in \$nestpar'
+            CALL message( 'pmc_init_model', 'PA0223', 3, 2, 0, 6, 0 )
+         ENDIF
+
+      ENDIF
+
+      CALL MPI_BCAST( m_nrofcpl, 1,          MPI_INTEGER, 0, MPI_COMM_WORLD, istat)
+      CALL MPI_BCAST( start_pe, m_nrofcpl+1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat)
+
+!
+!--   Broadcast coupling layout
+      DO  i = 1, m_nrofcpl
+         CALL MPI_BCAST( m_couplers(i)%name, LEN( m_couplers(i)%name ), MPI_CHARACTER, 0, MPI_COMM_WORLD, istat )
+         CALL MPI_BCAST( m_couplers(i)%id,           1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
+         CALL MPI_BCAST( m_couplers(i)%Parent_id,    1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
+         CALL MPI_BCAST( m_couplers(i)%npe_x,        1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
+         CALL MPI_BCAST( m_couplers(i)%npe_y,        1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
+         CALL MPI_BCAST( m_couplers(i)%lower_left_x, 1, MPI_REAL,    0, MPI_COMM_WORLD, istat )
+         CALL MPI_BCAST( m_couplers(i)%lower_left_y, 1, MPI_REAL,    0, MPI_COMM_WORLD, istat )
+      ENDDO
+
+!
+!--   Assign global MPI processes to individual models by setting the couple id
+      DO  i = 1, m_nrofcpl
+         IF ( m_world_rank >= start_pe(i)  .AND.  m_world_rank < start_pe(i+1) ) &
+         THEN
+            m_my_cpl_id = i
             EXIT
-         END if
-      END do
-      m_my_CPL_rank = m_world_rank-start_PE(i)
-
-      !   MPI_COMM_WORLD is the communicator for ALL models (MPI-1 approach)
-      !   The communictors for the individual models a created by MPI_Comm_split
-      !   The color of the model is represented by the Coupler id
-
-      CALL MPI_Comm_split (MPI_COMM_WORLD, m_my_CPL_id, m_my_CPL_rank, comm, istat)
-      if(istat /= MPI_SUCCESS) then
-         if(m_world_rank == 0) write(0,*) 'PMC: Error in MPI_Comm_split '
-         CALL MPI_Abort (MPI_COMM_WORLD, ierr, istat)
-      END if
-
-      !   Get size and rank of the model running on THIS PE
-
-      CALL  MPI_Comm_rank (comm, m_model_rank, istat)
-      CALL  MPI_Comm_size (comm, m_model_npes, istat)
-
-      !   Pe 0  brodcasts the Parent ID and Id of every model
-
-      do i=1,m_NrOfCpl
-         CALL MPI_Bcast (m_couplers(i)%Parent_Id,  1, MPI_INTEGER, 0,           MPI_COMM_WORLD, istat)
-         CALL MPI_Bcast (m_couplers(i)%Id,         1, MPI_INTEGER, 0,           MPI_COMM_WORLD, istat)
-      END do
-
+         ENDIF
+      ENDDO
+      m_my_cpl_rank = m_world_rank - start_pe(i)
+
+!
+!--   MPI_COMM_WORLD is the communicator for ALL models (MPI-1 approach).
+!--   The communictors for the individual models as created by MPI_COMM_SPLIT.
+!--   The color of the model is represented by the coupler id
+      CALL MPI_COMM_SPLIT( MPI_COMM_WORLD, m_my_cpl_id, m_my_cpl_rank, comm,   &
+                           istat )
+      IF ( istat /= MPI_SUCCESS )  THEN
+!
+!--      TO_DO: replace by message-call
+!--      TO_DO: Can this really happen, or is this just for the debugging phase?
+         IF ( m_world_rank == 0 )  WRITE (0,*) 'PMC: Error in MPI_Comm_split '
+         CALL MPI_ABORT( MPI_COMM_WORLD, ierr, istat )
+      ENDIF
+
+!
+!--   Get size and rank of the model running on this PE
+      CALL  MPI_COMM_RANK( comm, m_model_rank, istat )
+      CALL  MPI_COMM_SIZE( comm, m_model_npes, istat )
+
+!
+!--   Broadcast (from PE 0) the parent id and id of every model
+      DO  i = 1, m_nrofcpl
+         CALL MPI_BCAST( m_couplers(i)%parent_id, 1, MPI_INTEGER, 0,           &
+                         MPI_COMM_WORLD, istat )
+         CALL MPI_BCAST( m_couplers(i)%id,        1, MPI_INTEGER, 0,           &
+                         MPI_COMM_WORLD, istat )
+      ENDDO
+
+!
+!--   TO_DO: describe what is happening here, and why
       m_model_comm = comm
 
-      !   create Intercommunicator to server and clients
-      !   MPI_Intercomm_create creates an intercommunicator between 2 groups of different colors
-      !   The grouping with done prior with MPI_Comm_split
-
-      do i=2,m_NrOfCpl
-         if(m_couplers(i)%Parent_Id == m_my_CPL_id)   then                         !collect server PEs
-            tag = 500+i
-!kk            write(0,'(a,6i4)') 'server Part ',m_world_rank,m_world_npes,m_model_rank,m_model_npes,tag,start_pe(i)
-            CALL MPI_Intercomm_create (comm, 0, MPI_COMM_WORLD, start_pe(i), &
-               tag, m_to_client_comm(i), istat)
-
-            clientCount = clientCount+1
-            activeServer(i) = 1
-         else if (i == m_my_CPL_id)   then                                         !collect client PEs
-            tag = 500+i
-            CALL MPI_Intercomm_create (comm, 0, MPI_COMM_WORLD, start_pe(m_couplers(i)%Parent_Id), &
-               tag, m_to_server_comm, istat)
-!kk            write(0,'(a,7i4)') 'client Part',m_world_rank,m_world_npes,m_model_rank,m_model_npes,tag, start_pe(m_couplers(i)%Parent_Id)
-         END if
-         if(istat /= MPI_SUCCESS) then
-            if(m_world_rank == 0) write(0,*) 'PMC: Error in Coupler Setup '
-            CALL MPI_Abort (MPI_COMM_WORLD, ierr, istat)
-         END if
-      END do
-
-!     If I am server, count nr. of clients
-!     Although this loop is symetric on all processes, the active server flag is valid only on the individual PE.
-
-      ALLOCATE(PMC_Server_for_Client(ClientCount+1))
-      ClientCount = 0
-      do i=2,m_NrOfCpl
-         if(activeServer(i) == 1)  then
-            ClientCount = clientCount+1
-            PMC_Server_for_Client(ClientCount) = i
-         END if
-      END do
-      PMC_Server_for_Client(ClientCount+1) = -1
-
-      !   Get size of the server model
-
-      if(m_my_CPL_id > 1)  then
-         CALL MPI_Comm_remote_size (m_to_server_comm, m_server_remote_size, istat)
-      else
-         m_server_remote_size = -1             ! root model does not have a server
-      END if
-
-!      write(0,'(a,a,1x,9i7)') 'New Communicator ',trim(m_couplers(m_my_CPL_id)%name),m_world_npes,m_model_npes,m_world_rank, &
-!                                           m_model_rank,m_my_CPL_id,m_my_CPL_rank,m_server_remote_size,ClientCount
-
-      return
+!
+!--   Create intercommunicator between server and clients.
+!--   MPI_INTERCOMM_CREATE creates an intercommunicator between 2 groups of
+!--   different colors.
+!--   The grouping was done above with MPI_COMM_SPLIT
+      DO  i = 2, m_nrofcpl
+
+         IF ( m_couplers(i)%parent_id == m_my_cpl_id )  THEN
+!
+!--         Collect server PEs
+!--         TO_DO: explain in more details, what is done here
+            tag = 500 + i
+            CALL MPI_INTERCOMM_CREATE( comm, 0, MPI_COMM_WORLD, start_pe(i),   &
+                                       tag, m_to_client_comm(i), istat)
+            clientcount = clientcount + 1
+            activeserver(i) = 1
+
+         ELSEIF ( i == m_my_cpl_id)  THEN
+!
+!--         Collect client PEs
+!--         TO_DO: explain in more detail, what is happening here
+            tag = 500 + i
+            CALL MPI_INTERCOMM_CREATE( comm, 0, MPI_COMM_WORLD,                &
+                                       start_pe(m_couplers(i)%parent_id),      &
+                                       tag, m_to_server_comm, istat )
+         ENDIF
+
+         IF ( istat /= MPI_SUCCESS )  THEN
+!
+!--         TO_DO: replace by message-call
+!--         TO_DO: can this really happen, or is this just for debugging?
+            IF ( m_world_rank == 0 )  WRITE (0,*) 'PMC: Error in Coupler Setup '
+            CALL MPI_ABORT( MPI_COMM_WORLD, ierr, istat )
+         ENDIF
+
+      ENDDO
+
+!
+!--   If I am server, count the number of clients that I have
+!--   Although this loop is symmetric on all processes, the "activeserver" flag
+!--   is true (==1) on the respective individual PE only.
+      ALLOCATE( pmc_server_for_client(clientcount+1) )
+
+      clientcount = 0
+      DO  i = 2, m_nrofcpl
+         IF ( activeserver(i) == 1 )  THEN
+            clientcount = clientcount + 1
+            pmc_server_for_client(clientcount) = i
+         ENDIF
+      ENDDO
+!--   TO_DO: explain why this is done
+      pmc_server_for_client(clientcount+1) = -1
+
+!
+!--   Get the size of the server model
+!--   TO_DO: what does "size" mean here? Number of PEs?
+      IF ( m_my_cpl_id > 1 )  THEN
+         CALL MPI_COMM_REMOTE_SIZE( m_to_server_comm, m_server_remote_size,    &
+                                    istat)
+      ELSE
+!
+!--      The root model does not have a server
+         m_server_remote_size = -1             !
+      ENDIF
+!
+!--   Set myid to non-tero value except for the root domain. This is a setting
+!--   for the message routine which is called at the end of pmci_init. That
+!--   routine outputs messages for myid = 0, only. However, myid has not been
+!--   assigened so far, so that all PEs of the root model would output a
+!--   message. To avoid this, set myid to some other value except for PE0 of the
+!--   root domain.
+      IF ( m_world_rank /= 0 )  myid = 1
+
    END SUBROUTINE PMC_init_model
 
-!  Make module private variables available to palm
-
-   SUBROUTINE PMC_get_local_model_info (my_CPL_id, CPL_name,  npe_x, npe_y, lower_left_x, lower_left_y)
-      IMPLICIT     none
-      INTEGER,INTENT(OUT),optional             :: my_CPL_id
-      CHARACTER(len=*),INTENT(OUT),optional    :: CPL_name
-      INTEGER,INTENT(OUT),optional             :: npe_x
-      INTEGER,INTENT(OUT),optional             :: npe_y
-      REAL(kind=8),INTENT(OUT),optional        :: lower_left_x
-      REAL(kind=8),INTENT(OUT),optional        :: lower_left_y
-
-      if(present(my_CPL_id))    my_CPL_id    = m_my_CPL_id
-      if(present(CPL_name))     CPL_name     = m_couplers(my_CPL_id)%name
-      if(present(npe_x))        npe_x        = m_couplers(my_CPL_id)%npe_x
-      if(present(npe_y))        npe_y        = m_couplers(my_CPL_id)%npe_y
-      if(present(lower_left_x)) lower_left_x = m_couplers(my_CPL_id)%lower_left_x
-      if(present(lower_left_y)) lower_left_y = m_couplers(my_CPL_id)%lower_left_y
-
-      return
-   END  SUBROUTINE PMC_get_local_model_info
-
-   LOGICAL function PMC_is_RootModel ()
-      IMPLICIT     none
-
-      PMC_is_RootModel = (m_my_CPL_id == 1)
-
-      return
-   END  function PMC_is_RootModel
-
+
+!
+!-- Make module private variables available to palm
+!-- TO_DO: why can't they be available from the beginning, i.e. why do they
+!--        first have to be declared as different private variables?
+   SUBROUTINE pmc_get_local_model_info( my_cpl_id, my_cpl_parent_id, cpl_name, &
+                                        npe_x, npe_y, lower_left_x,            &
+                                        lower_left_y )
+
+      USE kinds
+
+      IMPLICIT NONE
+
+      CHARACTER(LEN=*), INTENT(OUT), OPTIONAL ::  cpl_name
+      INTEGER, INTENT(OUT), OPTIONAL          ::  my_cpl_id
+      INTEGER, INTENT(OUT), OPTIONAL          ::  my_cpl_parent_id
+      INTEGER, INTENT(OUT), OPTIONAL          ::  npe_x
+      INTEGER, INTENT(OUT), OPTIONAL          ::  npe_y
+      REAL(wp), INTENT(OUT), OPTIONAL         ::  lower_left_x
+      REAL(wp), INTENT(OUT), OPTIONAL         ::  lower_left_y
+
+!--   TO_DO: is the PRESENT clause really required here?
+      IF ( PRESENT( my_cpl_id )           )  my_cpl_id        = m_my_cpl_id
+      IF ( PRESENT( my_cpl_parent_id )    )  my_cpl_parent_id = m_couplers(my_cpl_id)%parent_id
+      IF ( PRESENT( cpl_name )            )  cpl_name         = m_couplers(my_cpl_id)%name
+      IF ( PRESENT( npe_x )               )  npe_x            = m_couplers(my_cpl_id)%npe_x
+      IF ( PRESENT( npe_y )               )  npe_y            = m_couplers(my_cpl_id)%npe_y
+      IF ( PRESENT( lower_left_x )        )  lower_left_x     = m_couplers(my_cpl_id)%lower_left_x
+      IF ( PRESENT( lower_left_y )        )  lower_left_y     = m_couplers(my_cpl_id)%lower_left_y
+
+   END SUBROUTINE pmc_get_local_model_info
+
+
+
+   LOGICAL function pmc_is_rootmodel( )
+
+      IMPLICIT NONE
+
+      pmc_is_rootmodel = ( m_my_cpl_id == 1 )
+
+   END FUNCTION pmc_is_rootmodel
+
+
+
+
+!-- TO_DO: what does this comment mean?
 ! Private SUBROUTINEs
-
-  SUBROUTINE read_coupling_layout (PMC_status)
-    IMPLICIT     none
-    INTEGER,INTENT(INOUT)           :: PMC_status
-    INTEGER                         :: i,iunit,istat
-    CHARACTER(LEN=*), PARAMETER     :: fname = 'PMC_couple_layout'
-    LOGICAL                         :: lex
-
-    m_NrOfCpl = 0
+ SUBROUTINE read_coupling_layout( nesting_mode, pmc_status )
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=7) ::  nesting_mode
+
+    INTEGER, INTENT(INOUT) ::  pmc_status
+    INTEGER                ::  i, istat, iunit
+
+    TYPE(pmc_layout), DIMENSION(pmc_max_modell) ::  domain_layouts
+
+
+    NAMELIST /nestpar/  domain_layouts, nesting_mode
+
+!
+!-- Initialize some coupling variables
+    domain_layouts(1:pmc_max_modell)%id = -1
+    m_nrofcpl =   0
     iunit     = 345
 
-    PMC_STATUS = PMC_STATUS_OK
-    INQUIRE(file=TRIM(fname), exist=lex)
-    IF (.NOT. lex) THEN
-       PMC_status = PMC_ERRO_NOF
+    pmc_status = pmc_status_ok
+
+!
+!-- Open the NAMELIST-file and read the nesting layout
+    CALL check_open( 11 )
+    READ ( 11, nestpar, IOSTAT=istat )
+
+    IF ( istat < 0 )  THEN
+!
+!--    No nestpar-NAMELIST found
+       pmc_status = pmc_no_namelist_found
+!
+!--    Set filepointer to the beginning of the file. Otherwise PE0 will later
+!--    be unable to read the inipar-NAMELIST
+       REWIND ( 11 )
        RETURN
-    END IF
-
-    open(iunit,file=TRIM(fname),status='OLD')
-    do i=1,PMC_MAX_MODELL
-      read(iunit,*,iostat=istat) m_couplers(i)%name                     &
-           , m_couplers(i)%id,m_couplers(i)%Parent_id                   &
-           , m_couplers(i)%npe_x,m_couplers(i)%npe_y                    &
-           , m_couplers(i)%lower_left_x, m_couplers(i)%lower_left_y
-      if(istat /= 0)  EXIT
-
-      write(0,'(a,a,1x,4i7,1x,2F10.2)') 'Set up Model  ',trim(m_couplers(i)%name),m_couplers(i)%id,m_couplers(i)%Parent_id, &
-                                                     m_couplers(i)%npe_x,m_couplers(i)%npe_y,                               &
-                                                     m_couplers(i)%lower_left_x,m_couplers(i)%lower_left_y
-
-      m_NrOfCpl = i
-    END do
-    close(iunit)
-
-    return
-  END SUBROUTINE read_coupling_layout
-
-END MODULE PMC_handle_communicator
+
+    ELSEIF ( istat > 0 )  THEN
+!
+!--    Errors in reading nestpar-NAMELIST
+       pmc_status = pmc_namelist_error
+       RETURN
+
+    ENDIF
+
+!
+!-- Output location message
+    CALL location_message( 'initialize communicators for nesting', .FALSE. )
+!
+!-- Assign the layout to the internally used variable
+    m_couplers = domain_layouts
+
+!
+!-- Get the number of nested models given in the nestpar-NAMELIST
+    DO  i = 1, pmc_max_modell
+
+       IF ( m_couplers(i)%id /= -1  .AND.  i <= pmc_max_modell )  THEN
+          WRITE ( 0, '(A,A,1X,4I7,1X,2F10.2)' )  'Set up Model  ',             &
+                              TRIM( m_couplers(i)%name ), m_couplers(i)%id,    &
+                              m_couplers(i)%Parent_id, m_couplers(i)%npe_x,    &
+                              m_couplers(i)%npe_y, m_couplers(i)%lower_left_x, &
+                              m_couplers(i)%lower_left_y
+       ELSE
+!
+!--       When id=-1 is found for the first time, the list of domains is
+!--       finished (or latest after pmc_max_modell entries
+          m_nrofcpl = i - 1
+          EXIT
+       ENDIF
+
+    ENDDO
+
+ END SUBROUTINE read_coupling_layout
+
+#endif
+ END MODULE pmc_handle_communicator
